module.exports = function(grunt) {
    grunt.initConfig({
        clean: ["lib/tictactoe/build"],
        sass: {
            dist: {
                files: {
                    'lib/tictactoe/src/css/tictactoe.css': 'lib/tictactoe/src/scss/tictactoe.scss'
                } 
            }
        },
        cssmin: {
            dist: {
                files: {
                    'lib/tictactoe/build/css/tictactoe.min.css': 'lib/tictactoe/src/css/tictactoe.css'
                }
            }
        },
        qunit: {
            dist: ['lib/tictactoe/test/*.html']
        },
        copy: {
            dist: {
                files: [
                    {
                        expand: false, filter: 'isFile', 
                        src: ['bower_dependencies/angular/angular.min.js'],
                        dest: 'lib/tictactoe/build/js/angular.min.js'
                    },
                    {
                        expand: false, filter: 'isFile', 
                        src: ['bower_dependencies/bootstrap/dist/css/bootstrap.min.css'],
                        dest: 'lib/tictactoe/build/css/bootstrap.min.css'
                    },
                    {
                        expand: false, filter: 'isFile', 
                        src: ['bower_dependencies/jquery-svg/jquery.svg.min.js'],
                        dest: 'lib/tictactoe/build/js/jquery.svg.min.js'
                    },
                    {
                        expand: false, filter: 'isFile', 
                        src: ['bower_dependencies/jquery-svg/jquery.svg.css'],
                        dest: 'lib/tictactoe/build/css/jquery.svg.css'
                    },
                    {
                        expand: false, filter: 'isFile', 
                        src: ['bower_dependencies/jquery/dist/jquery.min.js'],
                        dest: 'lib/tictactoe/build/js/jquery.min.js'
                    },
                    {
                        expand: true, filter: 'isFile', 
                        cwd: 'lib/tictactoe/src/views/',
                        src: ['**/*.html'],
                        dest: 'lib/tictactoe/build'
                    },
                    {
                        expand: true, filter: 'isFile', 
                        cwd: 'lib/tictactoe/src/img/',
                        src: ['*'],
                        dest: 'lib/tictactoe/build/img/'
                    }
                ]
            }
        },
        uglify: {
            dist: {
                files: {
                    'lib/tictactoe/build/js/tictactoe.min.js': [
                        'lib/tictactoe/src/tictactoe.js',
                        'lib/tictactoe/src/modules/TicTacToe.js',
                        'lib/tictactoe/src/services/DrawingService.js',
                        'lib/tictactoe/src/services/TicTacToeService.js',
                        'lib/tictactoe/src/controllers/TicTacToeController.js',
                        'lib/tictactoe/src/directives/GridDirective.js'
                    ]
                }
            }
        }
    });
    
    grunt.loadNpmTasks('grunt-contrib-clean');
    grunt.loadNpmTasks('grunt-contrib-sass');
    grunt.loadNpmTasks('grunt-contrib-cssmin');
    grunt.loadNpmTasks('grunt-contrib-qunit');
    grunt.loadNpmTasks('grunt-contrib-copy');
    grunt.loadNpmTasks('grunt-contrib-uglify');
    
    grunt.registerTask('default', ['clean', 'sass', 'cssmin', 'qunit', 'copy', 'uglify']);
}